from dataclasses import dataclass
import datetime
from typing import Optional
from xecution.models.topic import KlineTopic
from xecution.common.enums import Exchange, Mode

@dataclass
class RuntimeConfig:
    mode: Mode
    kline_topic: list[KlineTopic]
    start_time: datetime
    data_count: int
    API_Key: Optional[str] = None
    API_Secret: Optional[str] = None
    is_hedge_mode: bool = False
    datasource_topic: Optional[list[str]] = None
    leverage: Optional[int] = None
    exchange: Optional[Exchange] = None


# 定義一個訂單配置物件
@dataclass
class OrderConfig:
    market_type: str      # "spot" 或 "futures"
    symbol: str
    side: str             # "BUY" 或 "SELL"
    order_type: str       # "LIMIT" 或 "MARKET"
    quantity: float
    price: Optional[float] = None
    is_post_only: Optional[bool] = None